﻿@model Avira.MarketingResearch.Model.ViewModels.Masters.CurrencyConversionInsertDbViewModel

@{
    ViewData["Title"] = "Index";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<link href="https://code.jquery.com/ui/1.12.0/themes/smoothness/jquery-ui.css" type="text/css" rel="stylesheet" />
<link href="~/css/yearpicker.css" rel="stylesheet" />
<link href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.3.0/css/datepicker.min.css" rel="stylesheet" type="text/css" />
<style>
    .datepicker table tr td span {
        width: 100% !important;
    }

    select:disabled {
        cursor: not-allowed;
    }
</style>

<div class="container">
    <div class="row">
        <div class="col-md-2"></div>
        <div class="col-md-8">
            <div class="section-container section-with-top-border">
                @using (Html.BeginForm("Index", "CurrencyConversion", FormMethod.Post))
                {
                    @Html.AntiForgeryToken()

                    @Html.HiddenFor(model => model.CurrencyConversionId)
                    <div class="form-group">
                        @if (ViewBag.Message != null)
                        {
                            <div class="text-center">
                                <label class="alert alert-danger text-center viewbagmsg" role="alertdialog">@ViewBag.Message</label>
                            </div>
                        }

                    </div>
                    <div class="clearfix"></div>
                    <div class="form-horizontal">
                        @Html.ValidationSummary(true, "", new { @class = "text-danger" })
                        <input type="hidden" id="hiddenId" value="@ViewBag.CId" />
                        @{
                            string CurrencyId = ViewBag.CId;
                        }
                        @Html.HiddenFor(model => CurrencyId)
                        <div class="form-group">
                            <div class="col-md-6">
                                <p>
                                    Select Currency
                                </p>
                                @Html.DropDownListFor(model => CurrencyId, ((List<SelectListItem>)ViewBag.Currency).Select(m => new SelectListItem { Text = m.Text, Value = m.Value, Selected = m.Selected }), new { @class = "form-control ddlCurrency", disabled = "true" })
                            </div>
                            <div class="col-md-6">
                                <p>
                                    Currency
                                </p>
                                <input type="text" disabled value="United States Dollar(USD)" class="form-control" />
                            </div>
                        </div>
                        <div class="form-group">
                            <div class="col-md-12">
                                <p>
                                    Select Conversion Range Type
                                </p>
                                @Html.DropDownListFor(model => model.ConversionRangeType, ((List<SelectListItem>)ViewBag.ConversionRangeType).Select(m => new SelectListItem { Text = m.Text, Value = m.Value }), "Select Conversion Range Type", new { @class = "form-control" })
                            </div>
                        </div>
                        <div class="form-group" id="1">
                            <div class="col-md-6">
                                <p>
                                    Start Date
                                </p>
                                @Html.EditorFor(model => model.StartDate, new { htmlAttributes = new { @class = "form-control datetimepicker", @PlaceHolder = "mm/dd/yyyy" } })
                            </div>
                            <div class="col-md-6">
                                <p>
                                    End Date
                                </p>
                                @Html.EditorFor(model => model.EndDate, new { htmlAttributes = new { @class = "form-control datetimepicker", @PlaceHolder = "mm/dd/yyyy" } })
                            </div>
                        </div>
                        <div class="form-group" id="2">
                            <div class="col-md-6">
                                <p>
                                    Year
                                </p>
                                @Html.EditorFor(model => model.Year, new { htmlAttributes = new { @class = "form-control yearpicker", @PlaceHolder = "yyyy" } })
                            </div>
                            <div class="col-md-6">
                            </div>
                        </div>
                        <div class="form-group" id="3">
                            <div class="col-md-6">
                                <p>
                                    Quarter
                                </p>
                                <div class="date">
                                    @Html.EditorFor(model => model.Quarter, new { htmlAttributes = new { @class = "form-control", @id = "quarter", @PlaceHolder = "Quarter", style = "cursor: pointer" } })
                                </div>
                            </div>
                            <div class="col-md-6">
                            </div>
                        </div>
                        <div class="form-group">
                            <div class="col-md-6">
                                <p>
                                    Conversion Rate
                                </p>
                                @Html.EditorFor(model => model.ConversionRate, new { htmlAttributes = new { @class = "form-control" } })
                            </div>
                            <div class="col-md-6">
                            </div>
                        </div>
                        <br />
                        <div class="row">
                            <div class="col-md-4">
                                <div class="form-group">
                                    <input type="submit" value="Convert Currency" class="btn btn-inverse btn-primary btn-block width-150" />
                                </div>
                            </div>
                            <div class="col-md-4">
                                <div class="form-group">
                                    <a href="@Url.Action("Index","currency")" class="btn btn-inverse btn-primary btn-block width-150">
                                        Back to list
                                    </a>
                                </div>
                            </div>
                        </div>
                    </div>
                }
            </div>
        </div>
        <div class="col-md-2"></div>
    </div>

</div>
<div class="container ShowHideContainer">
    <div class="row">
        <div class="col-md-2"></div>
        <div class="col-md-10">
            <div class="section-container section-with-top-border">
                <div class="panel panel1 pagination-inverse m-b-0 clearfix">
                    <table id="data-table1" data-order='[[0,"asc"]]' class="table table-bordered table-hover">
                        <thead>
                            <tr class="inverse">
                                <th class="col-md-2">Currency Name</th>
                                <th class="col-md-1">Conversion Range Type</th>
                                <th class="col-md-1">Conversion Rate</th>
                                <th class="col-md-2">Start Date</th>
                                <th class="col-md-2">End Date</th>
                                <th class="col-md-1" style="pointer-events:none!important" data-sorting="disabled">Actions</th>
                            </tr>
                        </thead>
                    </table>
                </div>
                <div class="panel panel2 pagination-inverse m-b-0 clearfix">
                    <table id="data-table2" data-order='[[0,"asc"]]' class="table table-bordered table-hover">
                        <thead>
                            <tr class="inverse">
                                <th class="col-md-2">Currency Name</th>
                                <th class="col-md-1">Conversion Range Type</th>
                                <th class="col-md-1">Conversion Rate</th>
                                <th class="col-md-1">Year</th>
                                <th class="col-md-1" style="pointer-events:none!important" data-sorting="disabled">Actions</th>
                            </tr>
                        </thead>
                    </table>

                </div>
                <div class="panel panel3 pagination-inverse m-b-0 clearfix">
                    <table id="data-table3" data-order='[[0,"asc"]]' class="table table-bordered table-hover">
                        <thead>
                            <tr class="inverse">
                                <th class="col-md-2">Currency Name</th>
                                <th class="col-md-1">Conversion Range Type</th>
                                <th class="col-md-1">Conversion Rate</th>
                                <th class="col-md-2">Quarter</th>
                                <th class="col-md-1" style="pointer-events:none!important" data-sorting="disabled">Actions</th>
                            </tr>
                        </thead>
                    </table>
                </div>
            </div>
        </div>
    </div>
</div>

<script src="~/Scripts/jquery-3.0.0.js"></script>
<script src="https://code.jquery.com/ui/1.12.0/jquery-ui.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.3.0/js/bootstrap-datepicker.js" type="text/javascript"></script>
<script src="~/js/yearpicker.js" type="text/javascript"></script>

<script>
    $(document).ready(function () {
        $(".panel1,.panel2,.panel3").hide();
        var cId = $("#hiddenId").val();
        $(".ddlCurrency").val(cId);
        $('.datetimepicker').datepicker({
            dateFormat: "dd/M/yy",
            changeMonth: true,
            changeYear: true,
            yearRange: "-60:+0"
        });
        $("#1,#2,#3").hide();
        $('#ConversionRangeType').on("change", function () {
            var selectedDT = $(this).val();
            getCurrencyConversionGrid(selectedDT, cId);
            if (selectedDT == 1) {
                $("#1").show();
                $("#2,#3").hide();
            }
            else if (selectedDT == 2) {
                $("#2").show();
                $("#1,#3").hide();
            }
            else if (selectedDT == 3) {
                $("#3").show();
                $("#1,#2").hide();
            }
            else {
                $("#1,#2,#3").hide();
            }
        });
    });
    function getCurrencyConversionGrid(ConversionRangeType, CurrencyId) {
        $("#CurrencyConversionId").val("");
        $("#ConversionRate").val("");
        $("#Year").val("");
        $("#StartDate").val("");
        $("#EndDate").val("");
        $("#quarter").val("");

        var data = {
            ConversionRangeType: ConversionRangeType,
            CurrencyId: CurrencyId,
            Year: null,
        };

        if (ConversionRangeType == 1) {
            $("#data-table1").dataTable().fnDestroy();
            var table = $("#data-table1").DataTable({
                "oLanguage": {
                    "sEmptyTable": "There is no currency conversion for this currency."
                },
                "processing": true,
                "serverSide": true,
                "filter": true,
                "orderMulti": false,
                "ajax": {
                    "url": "/CurrencyConversion/LoadData",
                    "type": "POST",
                    "datatype": "json",
                    "data": data
                },

                "columns": [
                    { "data": "currencyName", "name": "currencyName" },
                    { "data": "conversionRangeType", "name": "conversionRangeType" },
                    { "data": "conversionRate", "name": "conversionRate" },
                    {
                        render: function (data, type, full, meta) {
                            var monthNames = [
                                "January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"
                            ];

                            var temp = full.startDate;
                            var month = new Date(temp).getUTCMonth();
                            var year = new Date(temp).getUTCFullYear();
                            var day = new Date(temp).getUTCDate() + 1;
                            var date = day + '/' + monthNames[month] + '/' + year;
                            return date;
                        }
                    },
                    {
                        render: function (data, type, full, meta) {
                            var monthNames = [
                                "January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"
                            ];

                            var temp = full.endDate;
                            var month = new Date(temp).getUTCMonth();
                            var year = new Date(temp).getUTCFullYear();
                            var day = new Date(temp).getUTCDate() + 1;
                            var date = day + '/' + monthNames[month] + '/' + year;
                            return date;
                        }
                    },
                    {
                        render: function (data, type, full, meta) {
                            return '<a class="btn btn-default edit_btn btn-xs btn-rounded p-l-10 p-r-10" href="javascript:void(0)"><i class="fas fa-edit"></i></a>';
                        }
                    }
                ]
            });

            $('#data-table1').on('click', 'tbody .edit_btn', function () {
                var data_row = table.row($(this).closest('tr')).data();
                var sd = new Date(data_row.startDate);
                var ed = new Date(data_row.endDate);
                var std = convertSDate(sd);
                $("#StartDate").val(std);
                var etd = convertSDate(ed);
                $("#EndDate").val(etd);
                $("#ConversionRate").val(data_row.conversionRate);
                $("#CurrencyConversionId").val(data_row.currencyConversionId);
            });
            function pad(n) {
                return n < 10 ? '0' + n : n;
            }

            function convertSDate(sd) {
                var monthNames = [
                    "January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"
                ];
                var date = sd.getDate();
                var month = sd.getMonth();
                var year = sd.getFullYear();
                return dateStringSd = pad(date) + "/" + monthNames[month] + "/" + year;
            }
            $(".panel1").show();
            $(".panel2,.panel3").hide();
        }
        else if (ConversionRangeType == 2) {
            $("#data-table2").dataTable().fnDestroy();
            var table = $("#data-table2").DataTable({
                "oLanguage": {
                    "sEmptyTable": "There is no currency conversion for this currency."
                },
                "processing": true,
                "serverSide": true,
                "filter": true,
                "orderMulti": false,
                "ajax": {
                    "url": "/CurrencyConversion/LoadData",
                    "type": "POST",
                    "datatype": "json",
                    "data": data
                },

                "columns": [
                    { "data": "currencyName", "name": "currencyName" },
                    { "data": "conversionRangeType", "name": "conversionRangeType" },
                    { "data": "conversionRate", "name": "conversionRate" },
                    { "data": "year", "name": "year" },
                    {
                        render: function (data, type, full, meta) {
                            return '<a class="btn btn-default btn-xs btn-rounded edit_btn p-l-10 p-r-10" href="javascript:void(0)"><i class="fas fa-edit"></i></a>';
                        }
                    }
                ]
            });

            $('#data-table2').on('click', 'tbody .edit_btn', function () {
                var data_row = table.row($(this).closest('tr')).data();
                $("#Year").val(data_row.year);
                $("#ConversionRate").val(data_row.conversionRate);
                $("#CurrencyConversionId").val(data_row.currencyConversionId);
            });

            $(".panel1,.panel3").hide();
            $(".panel2").show();
        }
        else if (ConversionRangeType == 3) {
            $("#data-table3").dataTable().fnDestroy();
            var table = $("#data-table3").DataTable({
                "oLanguage": {
                    "sEmptyTable": "There is no currency conversion for this currency."
                },
                "processing": true,
                "serverSide": true,
                "filter": true,
                "orderMulti": false,
                "ajax": {
                    "url": "/CurrencyConversion/LoadData",
                    "type": "POST",
                    "datatype": "json",
                    "data": data
                },

                "columns": [
                    { "data": "currencyName", "name": "currencyName" },
                    { "data": "conversionRangeType", "name": "conversionRangeType" },
                    { "data": "conversionRate", "name": "conversionRate" },
                    { "data": "quarter", "name": "quarter" },
                    {
                        render: function (data, type, full, meta) {
                            return '<a class="btn btn-default btn-xs edit_btn btn-rounded p-l-10 p-r-10" href="javascript:void(0)"><i class="fas fa-edit"></i></a>';
                        }
                    }
                ]
            });
            $('#data-table3').on('click', 'tbody .edit_btn', function () {
                var data_row = table.row($(this).closest('tr')).data();
                $("#quarter").val(data_row.quarter);
                $("#ConversionRate").val(data_row.conversionRate);
                $("#CurrencyConversionId").val(data_row.currencyConversionId);
            });
            $(".panel1,.panel2").hide();
            $(".panel3").show();
        }
        else {
            $(".panel1,.panel2,.panel3").hide();
        }
    }

    function checkConversionRangeType() {
        var selectedDT = $("#ConversionRangeType").val();
        if (selectedDT == 1) {
            $("#1").show();
            $("#2,#3").hide();
        }
        else if (selectedDT == 2) {
            $("#2").show();
            $("#1,#3").hide();
        }
        else if (selectedDT == 3) {
            $("#3").show();
            $("#1,#2").hide();
        }
        else {
            $("#1,#2,#3").hide();
        }
    }


    $.fn.datepicker.dates['qtrs'] = {
        days: ["Sunday", "Moonday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"],
        daysShort: ["Sun", "Moon", "Tue", "Wed", "Thu", "Fri", "Sat"],
        daysMin: ["Su", "Mo", "Tu", "We", "Th", "Fr", "Sa"],
        months: ["Q1", "Q2", "Q3", "Q4", "", "", "", "", "", "", "", ""],
        monthsShort: ["Jan&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Feb&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Mar", "Apr&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;May&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Jun", "Jul&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Aug&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Sep", "Oct&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Nov&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Dec", "", "", "", "", "", "", "", ""],
        today: "Today",
        clear: "Clear",
        format: "mm/dd/yyyy",
        titleFormat: "MM yyyy",
        /* Leverages same syntax as 'format' */
        weekStart: 0
    };

    $('#quarter').datepicker({
        format: "MM yyyy",
        minViewMode: 1,
        autoclose: true,
        language: "qtrs",
        forceParse: false
    }).on("show", function (event) {

        $(".month").each(function (index, element) {
            if (index > 3) $(element).hide();
        });
    });

</script>

